//
//  IAPHelper.m
//  InappDemo
//
//  Created by Ashish Nakoti on 2/20/14.
//  Copyright (c) 2014 evon. All rights reserved.
//

#import "IAPHelper.h"

@interface IAPHelper()
@property (copy, nonatomic) IAPHelperCallBack callback;


@end


@implementation IAPHelper

SINGLETON_FOR_CLASS(IAPHelper)

@synthesize product, productDescription, productID, productTitle, request;

-(void)getAllProductsDetails:(IAPHelperCallBack)callBack
{
    
 [[SKPaymentQueue defaultQueue] addTransactionObserver:self];
    
    self.productID = @"com.evon.sample.product";
    
    if ([SKPaymentQueue canMakePayments])
    {
        request = [[SKProductsRequest alloc] initWithProductIdentifiers:[NSSet setWithObject:self.productID]];
        
        request.delegate = self;
        NSLog(@"Started request");
        [request start];
    }
    else
        productDescription.text =
        @"Please enable In App Purchase in Settings";
    self.callback = callBack;
}

#pragma mark -
#pragma mark SKProductsRequestDelegate
-(void)request:(SKRequest *)request didFailWithError:(NSError *)error{
    
    NSLog(@"%@", error);
    
    [self productLists:error.description error:error callBack:self.callback];
}


-(void)productsRequest:(SKProductsRequest *)request didReceiveResponse:(SKProductsResponse *)response{
    
    NSArray *products = response.products;
    NSLog(@"product arr===%@",products);
    
    if (products.count != 0)
    {
        product = products[0];
        productTitle.text = product.localizedTitle;
        productDescription.text = product.localizedDescription;
        [self productLists:product.localizedDescription error:nil callBack:self.callback];
    } else {
        productTitle.text = @"Product not found";
    }
    
    for (SKProduct *productName in products)
    {
        NSLog(@"Product not found: %@", productName);
    }
}

-(void)productLists:(NSString *)text error:(NSError*)error callBack:(IAPHelperCallBack)callBack{

    if (error) {
        self.callback(text, error);
    }else
        self.callback(text, nil);
}

-(void)unlockFeature:(NSString *)text callBack:(IAPHelperCallBack)callBack
{
        self.callback(text, nil);
}

-(void)buyProduct:(IAPHelperCallBack)callBack{

    SKPayment *payment = [SKPayment paymentWithProduct:product];
    [[SKPaymentQueue defaultQueue] addPayment:payment];
    self.callback=callBack;
}


#pragma mark -
#pragma mark SKPaymentTransactionObserver

-(void)paymentQueue:(SKPaymentQueue *)queue updatedTransactions:(NSArray *)transactions
{
    for (SKPaymentTransaction *transaction in transactions)
    {
        switch (transaction.transactionState) {
            case SKPaymentTransactionStatePurchased:
                [self unlockFeature:@"Transaction Success" callBack:self.callback];
                [[SKPaymentQueue defaultQueue]
                 finishTransaction:transaction];
                break;
                
            case SKPaymentTransactionStateFailed:
                [self unlockFeature:@"Transaction Failed" callBack:self.callback];
                [[SKPaymentQueue defaultQueue]
                 finishTransaction:transaction];
                break;
                
            default:
                break;
        }
    }
}

-(UIView*)showAlertMessage:(NSString*)message title:(NSString*)title{

    UIAlertView *view = [[UIAlertView alloc]initWithTitle:title message:message delegate:nil cancelButtonTitle:@"Okay" otherButtonTitles:nil];
     [view show];
    return view;
}

@end
